diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-mlo-test.cc ns-3.43/src/wifi/test/wifi-mlo-test.cc
--- ns-3.42/src/wifi/test/wifi-mlo-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-mlo-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,86 +1,47 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
 
-#include "ns3/ap-wifi-mac.h"
+#include "wifi-mlo-test.h"
+
 #include "ns3/config.h"
 #include "ns3/eht-configuration.h"
-#include "ns3/frame-exchange-manager.h"
+#include "ns3/ht-frame-exchange-manager.h"
 #include "ns3/log.h"
+#include "ns3/mgt-action-headers.h"
 #include "ns3/mgt-headers.h"
 #include "ns3/mobility-helper.h"
 #include "ns3/multi-link-element.h"
-#include "ns3/multi-model-spectrum-channel.h"
 #include "ns3/node-list.h"
-#include "ns3/packet-socket-client.h"
 #include "ns3/packet-socket-helper.h"
-#include "ns3/packet-socket-server.h"
 #include "ns3/packet.h"
 #include "ns3/pointer.h"
-#include "ns3/qos-utils.h"
 #include "ns3/rng-seed-manager.h"
 #include "ns3/rr-multi-user-scheduler.h"
-#include "ns3/spectrum-wifi-helper.h"
 #include "ns3/spectrum-wifi-phy.h"
-#include "ns3/sta-wifi-mac.h"
 #include "ns3/string.h"
-#include "ns3/test.h"
+#include "ns3/vht-configuration.h"
 #include "ns3/wifi-acknowledgment.h"
 #include "ns3/wifi-assoc-manager.h"
 #include "ns3/wifi-mac-header.h"
 #include "ns3/wifi-mac-queue.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-protection.h"
-#include "ns3/wifi-psdu.h"
 
 #include <algorithm>
 #include <array>
 #include <iomanip>
-#include <optional>
 #include <sstream>
 #include <tuple>
-#include <vector>
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("WifiMloTest");
 
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Test the implementation of WifiAssocManager::GetNextAffiliatedAp(), which
- * searches a given RNR element for APs affiliated to the same AP MLD as the
- * reporting AP that sent the frame containing the element.
- */
-class GetRnrLinkInfoTest : public TestCase
-{
-  public:
-    /**
-     * Constructor
-     */
-    GetRnrLinkInfoTest();
-    ~GetRnrLinkInfoTest() override = default;
-
-  private:
-    void DoRun() override;
-};
-
 GetRnrLinkInfoTest::GetRnrLinkInfoTest()
     : TestCase("Check the implementation of WifiAssocManager::GetNextAffiliatedAp()")
 {
@@ -189,63 +150,15 @@
                           "Unexpected tbtt ID of the second reported AP");
 }
 
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * Test the WifiMac::SwapLinks() method.
- */
-class MldSwapLinksTest : public TestCase
+TypeId
+MldSwapLinksTest::TestWifiMac::GetTypeId()
 {
-    /**
-     * Test WifiMac subclass used to access the SwapLinks method.
-     */
-    class TestWifiMac : public WifiMac
-    {
-      public:
-        ~TestWifiMac() override = default;
-
-        using WifiMac::GetLinks;
-        using WifiMac::SwapLinks;
-
-        bool CanForwardPacketsTo(Mac48Address to) const override
-        {
-            return true;
-        }
-
-        void Enqueue(Ptr<Packet> packet, Mac48Address to) override
-        {
-        }
-
-      private:
-        void DoCompleteConfig() override
-        {
-        }
-    };
-
-  public:
-    MldSwapLinksTest();
-    ~MldSwapLinksTest() override = default;
-
-  protected:
-    void DoRun() override;
-
-  private:
-    /**
-     * Run a single test case.
-     *
-     * \param text string identifying the test case
-     * \param nLinks the number of links of the MLD
-     * \param links a set of pairs (from, to) each mapping a current link ID to the
-     *              link ID it has to become (i.e., link 'from' becomes link 'to')
-     * \param expected maps each link ID to the id of the PHY that is expected
-     *                 to operate on that link after the swap
-     */
-    void RunOne(std::string text,
-                std::size_t nLinks,
-                const std::map<uint8_t, uint8_t>& links,
-                const std::map<uint8_t, uint8_t>& expected);
-};
+    static TypeId tid = TypeId("ns3::TestWifiMac")
+                            .SetParent<WifiMac>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<TestWifiMac>();
+    return tid;
+}
 
 MldSwapLinksTest::MldSwapLinksTest()
     : TestCase("Test the WifiMac::SwapLinks() method")
@@ -258,33 +171,62 @@
                          const std::map<uint8_t, uint8_t>& links,
                          const std::map<uint8_t, uint8_t>& expected)
 {
-    TestWifiMac mac;
+    auto mac = CreateObjectWithAttributes<TestWifiMac>("QosSupported",
+                                                       BooleanValue(false),
+                                                       "Txop",
+                                                       PointerValue(CreateObject<Txop>()));
 
     std::vector<Ptr<WifiPhy>> phys;
-    for (std::size_t i = 0; i < nLinks; i++)
+    std::vector<Ptr<FrameExchangeManager>> feManagers;
+
+    for (std::size_t i = 0; i < nLinks; ++i)
     {
-        phys.emplace_back(CreateObject<SpectrumWifiPhy>());
+        auto phy = CreateObject<SpectrumWifiPhy>();
+        phy->SetPhyId(i);
+        phys.emplace_back(phy);
+        feManagers.emplace_back(CreateObject<TestFrameExchangeManager>());
     }
-    mac.SetWifiPhys(phys); // create links containing the given PHYs
+    mac->SetWifiPhys(phys); // create links containing the given PHYs
+    mac->SetFrameExchangeManagers(feManagers);
+    mac->GetTxop()->SetWifiMac(mac);
 
-    mac.SwapLinks(links);
+    // set CWmin of each Txop LinkEntity to the link ID, so that we can check where it has moved
+    for (std::size_t id = 0; id < nLinks; ++id)
+    {
+        mac->GetTxop()->SetMinCw(id, id);
+    }
+
+    mac->SwapLinks(links);
 
-    NS_TEST_EXPECT_MSG_EQ(mac.GetNLinks(), nLinks, "Number of links changed after swapping");
+    NS_TEST_EXPECT_MSG_EQ(mac->GetNLinks(), nLinks, "Number of links changed after swapping");
 
     for (const auto& [linkId, phyId] : expected)
     {
-        NS_TEST_ASSERT_MSG_EQ(mac.GetLinks().count(linkId),
-                              1,
+        NS_TEST_ASSERT_MSG_EQ(mac->GetLinks().contains(linkId),
+                              true,
                               "Link ID " << +linkId << " does not exist");
 
         NS_TEST_ASSERT_MSG_LT(+phyId, nLinks, "Invalid PHY ID");
 
         // the id of the PHY operating on a link is the original ID of the link
-        NS_TEST_EXPECT_MSG_EQ(mac.GetWifiPhy(linkId),
-                              phys.at(phyId),
+        NS_TEST_EXPECT_MSG_EQ(+mac->GetWifiPhy(linkId)->GetPhyId(),
+                              +phyId,
                               text << ": Link " << +phyId << " has not been moved to link "
                                    << +linkId);
+
+        NS_TEST_EXPECT_MSG_EQ(
+            +DynamicCast<TestFrameExchangeManager>(mac->GetFrameExchangeManager(linkId))
+                 ->GetLinkId(),
+            +linkId,
+            text << ": Link ID stored by FrameExchangeManager has not been updated");
+
+        NS_TEST_EXPECT_MSG_EQ(mac->GetTxop()->GetMinCw(linkId),
+                              +phyId,
+                              text << ": Txop Link entity " << +phyId
+                                   << " has not been moved to link " << +linkId);
     }
+
+    mac->Dispose();
 }
 
 void
@@ -297,6 +239,10 @@
            3,
            {{0, 2}, {2, 1}},
            {{0, 1}, {1, 2}, {2, 0}});
+    RunOne("A different non-circular swapping, same result",
+           3,
+           {{1, 0}, {2, 1}},
+           {{0, 1}, {1, 2}, {2, 0}});
     RunOne("One move only, autodetect how to complete the swapping",
            3,
            {{2, 0}},
@@ -309,169 +255,157 @@
     RunOne("Move all links to a new set of IDs", 2, {{0, 2}, {1, 3}}, {{2, 0}, {3, 1}});
 }
 
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Base class for Multi-Link Operations tests
- *
- * Three spectrum channels are created, one for each band (2.4 GHz, 5 GHz and 6 GHz).
- * Each PHY object is attached to the spectrum channel corresponding to the PHY band
- * in which it is operating.
- */
-class MultiLinkOperationsTestBase : public TestCase
+AidAssignmentTest::AidAssignmentTest(const std::vector<std::set<uint8_t>>& linkIds)
+    : TestCase("Test the assignment of AIDs"),
+      m_linkChannels({"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}"}),
+      m_linkIds(linkIds),
+      m_expectedAid(1) // AID for first station
 {
-  public:
-    /**
-     * Configuration parameters common to all subclasses
-     */
-    struct BaseParams
-    {
-        std::vector<std::string>
-            staChannels; //!< the strings specifying the operating channels for the non-AP MLD
-        std::vector<std::string>
-            apChannels; //!< the strings specifying the operating channels for the AP MLD
-        std::vector<uint8_t>
-            fixedPhyBands; //!< list of IDs of non-AP MLD PHYs that cannot switch band
-    };
+}
 
-    /**
-     * Constructor
-     *
-     * \param name The name of the new TestCase created
-     * \param nStations the number of stations to create
-     * \param baseParams common configuration parameters
-     */
-    MultiLinkOperationsTestBase(const std::string& name,
-                                uint8_t nStations,
-                                const BaseParams& baseParams);
-    ~MultiLinkOperationsTestBase() override = default;
+void
+AidAssignmentTest::DoSetup()
+{
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(1);
+    int64_t streamNumber{1};
 
-  protected:
-    /**
-     * Callback invoked when a FEM passes PSDUs to the PHY.
-     *
-     * \param mac the MAC transmitting the PSDUs
-     * \param phyId the ID of the PHY transmitting the PSDUs
-     * \param psduMap the PSDU map
-     * \param txVector the TX vector
-     * \param txPowerW the tx power in Watts
-     */
-    virtual void Transmit(Ptr<WifiMac> mac,
-                          uint8_t phyId,
-                          WifiConstPsduMap psduMap,
-                          WifiTxVector txVector,
-                          double txPowerW);
+    NodeContainer wifiApNode;
+    wifiApNode.Create(1);
+    NodeContainer wifiStaNodes;
 
-    /**
-     * Check that the expected Capabilities information elements are present in the given
-     * management frame based on the band in which the given link is operating.
-     *
-     * \param mpdu the given management frame
-     * \param mac the MAC transmitting the management frame
-     * \param phyId the ID of the PHY transmitting the management frame
-     */
-    void CheckCapabilities(Ptr<WifiMpdu> mpdu, Ptr<WifiMac> mac, uint8_t phyId);
+    WifiHelper wifi;
+    wifi.SetStandard(WIFI_STANDARD_80211be);
+    wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
+                                 "DataMode",
+                                 StringValue("EhtMcs0"),
+                                 "ControlMode",
+                                 StringValue("HtMcs0"));
 
-    /**
-     * Function to trace packets received by the server application
-     * \param nodeId the ID of the node that received the packet
-     * \param p the packet
-     * \param addr the address
-     */
-    virtual void L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr);
+    auto channel = CreateObject<MultiModelSpectrumChannel>();
 
-    /**
-     * \param sockAddr the packet socket address identifying local outgoing interface
-     *                 and remote address
-     * \param count the number of packets to generate
-     * \param pktSize the size of the packets to generate
-     * \param delay the delay with which traffic generation starts
-     * \param priority user priority for generated packets
-     * \return an application generating the given number packets of the given size destined
-     *         to the given packet socket address
-     */
-    Ptr<PacketSocketClient> GetApplication(const PacketSocketAddress& sockAddr,
-                                           std::size_t count,
-                                           std::size_t pktSize,
-                                           Time delay = Seconds(0),
-                                           uint8_t priority = 0) const;
+    // AP MLD
+    SpectrumWifiPhyHelper phyHelper(3);
+    phyHelper.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
+    phyHelper.SetPcapCaptureType(WifiPhyHelper::PcapCaptureType::PCAP_PER_LINK);
+    uint8_t linkId = 0;
+    for (const auto& str : m_linkChannels)
+    {
+        phyHelper.Set(linkId++, "ChannelSettings", StringValue(str));
+    }
+    phyHelper.SetChannel(channel);
 
-    void DoSetup() override;
+    WifiMacHelper mac;
+    mac.SetType("ns3::ApWifiMac",
+                "Ssid",
+                SsidValue(Ssid("ns-3-ssid")),
+                "BeaconGeneration",
+                BooleanValue(true));
 
-    /// PHY band-indexed map of spectrum channels
-    using ChannelMap = std::map<FrequencyRange, Ptr<MultiModelSpectrumChannel>>;
+    auto apDevice = wifi.Install(phyHelper, mac, wifiApNode);
 
-    /**
-     * Uplink or Downlink direction
-     */
-    enum Direction
+    // non-AP STAs/MLDs
+    for (const auto& links : m_linkIds)
     {
-        DL = 0,
-        UL
-    };
+        phyHelper = SpectrumWifiPhyHelper(links.size());
+        phyHelper.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
+        phyHelper.SetPcapCaptureType(WifiPhyHelper::PcapCaptureType::PCAP_PER_LINK);
+        linkId = 0;
+        for (const auto& id : links)
+        {
+            phyHelper.Set(linkId++, "ChannelSettings", StringValue(m_linkChannels.at(id)));
+        }
+        phyHelper.SetChannel(channel);
+        phyHelper.Set("FixedPhyBand", BooleanValue(true));
+
+        WifiMacHelper mac;
+        mac.SetType("ns3::StaWifiMac",
+                    "Ssid", // first non-AP STA/MLD only starts associating
+                    SsidValue(Ssid(m_staDevices.GetN() == 0 ? "ns-3-ssid" : "default")),
+                    "ActiveProbing",
+                    BooleanValue(false));
+
+        auto staNode = CreateObject<Node>();
+        auto staDevice = wifi.Install(phyHelper, mac, staNode);
+        wifiStaNodes.Add(staNode);
+        m_staDevices.Add(staDevice);
+    }
 
-    /**
-     * Check that the Address 1 and Address 2 fields of the given PSDU contain device MAC addresses.
-     *
-     * \param psdu the given PSDU
-     * \param direction indicates direction for management frames (DL or UL)
-     */
-    void CheckAddresses(Ptr<const WifiPsdu> psdu,
-                        std::optional<Direction> direction = std::nullopt);
+    // Assign fixed streams to random variables in use
+    streamNumber += WifiHelper::AssignStreams(apDevice, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(m_staDevices, streamNumber);
 
-    /// Information about transmitted frames
-    struct FrameInfo
+    auto positionAlloc = CreateObject<ListPositionAllocator>();
+    positionAlloc->Add(Vector(0.0, 0.0, 0.0));
+    MobilityHelper mobility;
+    mobility.SetPositionAllocator(positionAlloc);
+    mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
+    mobility.Install(wifiApNode);
+    mobility.Install(wifiStaNodes);
+
+    for (uint32_t i = 0; i < m_staDevices.GetN(); ++i)
     {
-        Time startTx;             ///< TX start time
-        WifiConstPsduMap psduMap; ///< transmitted PSDU map
-        WifiTxVector txVector;    ///< TXVECTOR
-        uint8_t linkId;           ///< link ID
-        uint8_t phyId;            ///< ID of the transmitting PHY
-    };
+        auto mac = StaticCast<WifiNetDevice>(m_staDevices.Get(i))->GetMac();
+        mac->TraceConnectWithoutContext(
+            "Assoc",
+            MakeCallback(&AidAssignmentTest::SetSsid, this).Bind(DynamicCast<StaWifiMac>(mac)));
+    }
+}
 
-    std::vector<FrameInfo> m_txPsdus;             ///< transmitted PSDUs
-    const std::vector<std::string> m_staChannels; ///< strings specifying channels for STA
-    const std::vector<std::string> m_apChannels;  ///< strings specifying channels for AP
-    const std::vector<uint8_t> m_fixedPhyBands;   ///< links on non-AP MLD with fixed PHY band
-    Ptr<ApWifiMac> m_apMac;                       ///< AP wifi MAC
-    std::vector<Ptr<StaWifiMac>> m_staMacs;       ///< STA wifi MACs
-    uint8_t m_nStations;                          ///< number of stations to create
-    uint16_t m_lastAid;                           ///< AID of last associated station
-    Time m_duration{Seconds(1)};                  ///< simulation duration
-    std::vector<std::size_t> m_rxPkts; ///< number of packets received at application layer
-                                       ///< by each node (index is node ID)
+void
+AidAssignmentTest::SetSsid(Ptr<StaWifiMac> staMac, Mac48Address /* apAddr */)
+{
+    const auto aid = staMac->GetAssociationId();
 
-  private:
-    /**
-     * Reset the given PHY helper, use the given strings to set the ChannelSettings
-     * attribute of the PHY objects to create, and attach them to the given spectrum
-     * channels appropriately.
-     *
-     * \param helper the given PHY helper
-     * \param channels the strings specifying the operating channels to configure
-     * \param channelMap the created spectrum channels
-     */
-    void SetChannels(SpectrumWifiPhyHelper& helper,
-                     const std::vector<std::string>& channels,
-                     const ChannelMap& channelMap);
+    std::stringstream linksStr;
+    const auto setupLinks = staMac->GetSetupLinkIds();
+    std::copy(setupLinks.cbegin(), setupLinks.cend(), std::ostream_iterator<int>(linksStr, " "));
 
-    /**
-     * Set the SSID on the next station that needs to start the association procedure.
-     * This method is connected to the ApWifiMac's AssociatedSta trace source.
-     * Start generating traffic (if needed) when all stations are associated.
-     *
-     * \param aid the AID assigned to the previous associated STA
-     */
-    void SetSsid(uint16_t aid, Mac48Address /* addr */);
+    NS_LOG_INFO("STA " << staMac->GetAddress() << " associated with AID " << aid << " links "
+                       << linksStr.str());
 
-    /**
-     * Start the generation of traffic (needs to be overridden)
-     */
-    virtual void StartTraffic()
+    NS_TEST_EXPECT_MSG_EQ(aid, m_expectedAid, "Unexpected AID for STA " << staMac->GetAddress());
+    // For non-AP MLDs, check that the requested links have been setup (for non-AP STAs, link ID
+    // as seen by the non-AP STAs is always zero and could not match link ID as seen by the AP MLD)
+    if (m_linkIds.at(aid - 1).size() > 1)
+    {
+        NS_TEST_EXPECT_MSG_EQ((staMac->GetSetupLinkIds() == m_linkIds.at(aid - 1)),
+                              true,
+                              "Unexpected set of setup links " << linksStr.str());
+    }
+
+    if (m_expectedAid < m_staDevices.GetN())
+    {
+        // let the next STA associate with the AP
+        StaticCast<WifiNetDevice>(m_staDevices.Get(m_expectedAid))
+            ->GetMac()
+            ->SetSsid(Ssid("ns-3-ssid"));
+        ++m_expectedAid;
+    }
+    else
+    {
+        Simulator::Stop(MilliSeconds(5)); // allow sending Ack response to Association Response
+    }
+}
+
+void
+AidAssignmentTest::DoRun()
+{
+    Simulator::Stop(Seconds(5)); // simulation will stop earlier if all STAs complete association
+    Simulator::Run();
+
+    NS_TEST_EXPECT_MSG_EQ(m_expectedAid, m_staDevices.GetN(), "Not all STAs completed association");
+
+    for (uint32_t i = 0; i < m_staDevices.GetN(); ++i)
     {
+        auto mac = StaticCast<WifiNetDevice>(m_staDevices.Get(i))->GetMac();
+        mac->TraceDisconnectWithoutContext(
+            "Assoc",
+            MakeCallback(&AidAssignmentTest::SetSsid, this).Bind(DynamicCast<StaWifiMac>(mac)));
     }
-};
+
+    Simulator::Destroy();
+}
 
 MultiLinkOperationsTestBase::MultiLinkOperationsTestBase(const std::string& name,
                                                          uint8_t nStations,
@@ -575,20 +509,10 @@
     {
         std::stringstream ss;
         ss << std::setprecision(10) << "PSDU #" << m_txPsdus.size() << " Link ID "
-           << +linkId.value() << " Phy ID " << +phyId << " " << psdu->GetHeader(0).GetTypeString()
-           << " #MPDUs " << psdu->GetNMpdus() << " duration/ID " << psdu->GetHeader(0).GetDuration()
-           << " RA = " << psdu->GetAddr1() << " TA = " << psdu->GetAddr2()
-           << " ADDR3 = " << psdu->GetHeader(0).GetAddr3()
-           << " ToDS = " << psdu->GetHeader(0).IsToDs()
-           << " FromDS = " << psdu->GetHeader(0).IsFromDs();
-        if (psdu->GetHeader(0).IsQosData())
+           << +linkId.value() << " Phy ID " << +phyId << " #MPDUs " << psdu->GetNMpdus();
+        for (auto it = psdu->begin(); it != psdu->end(); ++it)
         {
-            ss << " seqNo = {";
-            for (auto& mpdu : *PeekPointer(psdu))
-            {
-                ss << mpdu->GetHeader().GetSequenceNumber() << ",";
-            }
-            ss << "} TID = " << +psdu->GetHeader(0).GetQosTid();
+            ss << "\n" << **it;
         }
         NS_LOG_INFO(ss.str());
 
@@ -690,6 +614,7 @@
 {
     helper = SpectrumWifiPhyHelper(channels.size());
     helper.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
+    helper.SetPcapCaptureType(WifiPhyHelper::PcapCaptureType::PCAP_PER_LINK);
 
     uint8_t linkId = 0;
     for (const auto& str : channels)
@@ -761,8 +686,8 @@
     // staPhyHelper.EnablePcap("wifi-mlo_STA", staDevices);
 
     // Assign fixed streams to random variables in use
-    streamNumber += wifi.AssignStreams(apDevices, streamNumber);
-    streamNumber += wifi.AssignStreams(staDevices, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(apDevices, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(staDevices, streamNumber);
 
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
@@ -876,152 +801,21 @@
     Simulator::Schedule(MilliSeconds(5), &MultiLinkOperationsTestBase::StartTraffic, this);
 }
 
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Multi-Link Discovery & Setup test.
- *
- * This test sets up an AP MLD and a non-AP MLD having a variable number of links.
- * The RF channels to set each link to are provided as input parameters through the test
- * case constructor, along with the identifiers (starting at 0) of the links that cannot
- * switch PHY band (if any). The links that are expected to be setup are also provided as input
- * parameters. This test verifies that the management frames exchanged during ML discovery
- * and ML setup contain the expected values and that the two MLDs setup the expected links.
- *
- * The negotiated TID-to-link mapping is tested by verifying that generated QoS data frames of
- * a given TID are transmitted on links which the TID is mapped to. Specifically, the following
- * operations are performed separately for each direction (downlink and uplink). A first TID
- * is searched such that it is not mapped on all the setup links. If no such TID is found, only
- * QoS frames of TID 0 are generated. Otherwise, we also search for a second TID that is mapped
- * to a link set that is disjoint with the link set to which the first TID is mapped. If such a
- * TID is found, QoS frames of both the first TID and the second TID are generated; otherwise,
- * only QoS frames of the first TID are generated. For each TID, a number of QoS frames equal
- * to the number of setup links is generated. For each TID, we check that the first N QoS frames,
- * where N is the size of the link set to which the TID is mapped, are transmitted concurrently,
- * while the following QoS frames are sent after the first QoS frame sent on the same link. We
- * also check that all the QoS frames are sent on a link belonging to the link set to which the
- * TID is mapped. If QoS frames of two TIDs are generated, we also check that the first N QoS
- * frames of a TID, where N is the size of the link set to which that TID is mapped, are sent
- * concurrently with the first M QoS frames of the other TID, where M is the size of the link
- * set to which the other TID is mapped.
- */
-class MultiLinkSetupTest : public MultiLinkOperationsTestBase
-{
-  public:
-    /**
-     * Constructor
-     *
-     * \param baseParams common configuration parameters
-     * \param scanType the scan type (active or passive)
-     * \param setupLinks a list of links that are expected to be setup. In case one of the two
-     *                   devices has a single link, the ID of the link on the MLD is indicated
-     * \param apNegSupport TID-to-Link Mapping negotiation supported by the AP MLD (0, 1, or 3)
-     * \param dlTidToLinkMapping DL TID-to-Link Mapping for EHT configuration of non-AP MLD
-     * \param ulTidToLinkMapping UL TID-to-Link Mapping for EHT configuration of non-AP MLD
-     */
-    MultiLinkSetupTest(const BaseParams& baseParams,
-                       WifiScanType scanType,
-                       const std::vector<uint8_t>& setupLinks,
-                       WifiTidToLinkMappingNegSupport apNegSupport,
-                       const std::string& dlTidToLinkMapping,
-                       const std::string& ulTidToLinkMapping);
-    ~MultiLinkSetupTest() override = default;
-
-  protected:
-    void DoSetup() override;
-    void DoRun() override;
-
-  private:
-    void StartTraffic() override;
-
-    /**
-     * Check correctness of Multi-Link Setup procedure.
-     */
-    void CheckMlSetup();
-
-    /**
-     * Check that links that are not setup on the non-AP MLD are disabled. Also, on the AP side,
-     * check that the queue storing QoS data frames destined to the non-AP MLD has a mask for a
-     * link if and only if the link has been setup by the non-AO MLD.
-     */
-    void CheckDisabledLinks();
-
-    /**
-     * Check correctness of the given Beacon frame.
-     *
-     * \param mpdu the given Beacon frame
-     * \param linkId the ID of the link on which the Beacon frame was transmitted
-     */
-    void CheckBeacon(Ptr<WifiMpdu> mpdu, uint8_t linkId);
-
-    /**
-     * Check correctness of the given Probe Response frame.
-     *
-     * \param mpdu the given Probe Response frame
-     * \param linkId the ID of the link on which the Probe Response frame was transmitted
-     */
-    void CheckProbeResponse(Ptr<WifiMpdu> mpdu, uint8_t linkId);
-
-    /**
-     * Check correctness of the given Association Request frame.
-     *
-     * \param mpdu the given Association Request frame
-     * \param linkId the ID of the link on which the Association Request frame was transmitted
-     */
-    void CheckAssocRequest(Ptr<WifiMpdu> mpdu, uint8_t linkId);
-
-    /**
-     * Check correctness of the given Association Response frame.
-     *
-     * \param mpdu the given Association Response frame
-     * \param linkId the ID of the link on which the Association Response frame was transmitted
-     */
-    void CheckAssocResponse(Ptr<WifiMpdu> mpdu, uint8_t linkId);
-
-    /**
-     * Check that QoS data frames are sent on links their TID is mapped to.
-     *
-     * \param mpdu the given QoS data frame
-     * \param linkId the ID of the link on which the QoS data frame was transmitted
-     * \param index index of the QoS data frame in the vector of transmitted PSDUs
-     */
-    void CheckQosData(Ptr<WifiMpdu> mpdu, uint8_t linkId, std::size_t index);
-
-    const std::vector<uint8_t> m_setupLinks; //!< IDs of the expected links to setup
-    WifiScanType m_scanType;                 //!< the scan type (active or passive)
-    std::size_t m_nProbeResp; //!< number of Probe Responses received by the non-AP MLD
-    WifiTidToLinkMappingNegSupport
-        m_apNegSupport;                //!< TID-to-Link Mapping negotiation supported by the AP MLD
-    std::string m_dlTidLinkMappingStr; //!< DL TID-to-Link Mapping for non-AP MLD EHT configuration
-    std::string m_ulTidLinkMappingStr; //!< UL TID-to-Link Mapping for non-AP MLD EHT configuration
-    WifiTidLinkMapping m_dlTidLinkMapping; //!< expected DL TID-to-Link Mapping requested by non-AP
-                                           //!< MLD and accepted by AP MLD
-    WifiTidLinkMapping m_ulTidLinkMapping; //!< expected UL TID-to-Link Mapping requested by non-AP
-                                           //!< MLD and accepted by AP MLD
-    uint8_t m_dlTid1;                      //!< the TID of the first set of DL QoS data frames
-    uint8_t m_ulTid1;                      //!< the TID of the first set of UL QoS data frames
-    std::optional<uint8_t> m_dlTid2;       //!< the TID of the optional set of DL QoS data frames
-    std::optional<uint8_t> m_ulTid2;       //!< the TID of the optional set of UL QoS data frames
-    std::vector<std::size_t>
-        m_qosFrames1; //!< indices of QoS frames of the first set in the vector of TX PSDUs
-    std::vector<std::size_t>
-        m_qosFrames2; //!< indices of QoS frames of the optional set in the vector of TX PSDUs
-};
-
 MultiLinkSetupTest::MultiLinkSetupTest(const BaseParams& baseParams,
                                        WifiScanType scanType,
                                        const std::vector<uint8_t>& setupLinks,
                                        WifiTidToLinkMappingNegSupport apNegSupport,
                                        const std::string& dlTidToLinkMapping,
-                                       const std::string& ulTidToLinkMapping)
+                                       const std::string& ulTidToLinkMapping,
+                                       bool support160MHzOp)
     : MultiLinkOperationsTestBase("Check correctness of Multi-Link Setup", 1, baseParams),
       m_setupLinks(setupLinks),
       m_scanType(scanType),
       m_nProbeResp(0),
       m_apNegSupport(apNegSupport),
       m_dlTidLinkMappingStr(dlTidToLinkMapping),
-      m_ulTidLinkMappingStr(ulTidToLinkMapping)
+      m_ulTidLinkMappingStr(ulTidToLinkMapping),
+      m_support160MHzOp(support160MHzOp)
 {
 }
 
@@ -1127,6 +921,19 @@
             mac->SetAttribute(attrName, UintegerValue(100));
         }
     }
+
+    // configure support for 160 MHz operations and set the channels again to check that they
+    // are compatible
+    for (auto staMac : m_staMacs)
+    {
+        staMac->GetVhtConfiguration()->SetAttribute("Support160MHzOperation",
+                                                    BooleanValue(m_support160MHzOp));
+        uint8_t linkId = 0;
+        for (const auto& str : m_staChannels)
+        {
+            staMac->GetWifiPhy(linkId++)->SetAttribute("ChannelSettings", StringValue(str));
+        }
+    }
 }
 
 void
@@ -1203,7 +1010,7 @@
             break;
 
         case WIFI_MAC_QOSDATA:
-            CheckQosData(mpdu, linkId, index);
+            CheckQosData(mpdu, frameInfo.txVector, linkId, index);
             break;
 
         default:
